AddCSLuaFile()

if SERVER then
    util.AddNetworkString( "ShowPassportToPlayer" )
end

if CLIENT then

    local currentWindow = currentWindow or nil
    

    net.Receive( "ShowPassportToPlayer", function()
        surface.PlaySound( "ui/hint.wav" )
        local ply = net.ReadEntity()
        local xtra = net.ReadBool()
        if IsValid( currentWindow ) then
            currentWindow:MoveTo( 25, ScrH() + 378, 1, 0, 0.25, function( anim2, panel2 )
                currentWindow:Close()
            end )
        end

        local PassportPanel = vgui.Create( "DFrame" )
        PassportPanel:SetSize( 600, 378 )
        PassportPanel:SetPos( 25, ScrH() + 378 )
        PassportPanel:MoveTo( 25, ScrH() - 378, 1, 0, 0.25, function( anim, panel )
            currentWindow = PassportPanel
            timer.Create( "CloseCurrentPassport", 15, 1, function() --change 15 to your desired number of seconds
                currentWindow:MoveTo( 25, ScrH() + 378, 1, 0, 0.25, function( anim2, panel2 )
                    currentWindow:Close()
                    currentWindow = nil
                end )
            end )
        end )

        local PassportMat = vgui.Create( "DImage", PassportPanel )
        PassportMat:SetPos( 0, -378 )
        PassportMat:SetSize( 600, 756 )
        PassportMat:SetMaterial( "models/police/passvtf_g" )
        PassportMat.AutoSize = false

        local PlayerModelMat = vgui.Create( "Material", PassportPanel )
        PlayerModelMat:SetPos( 31, 57 )
        PlayerModelMat:SetSize( 166, 192 )
        PlayerModelMat:SetMaterial( "spawnicons/" .. string.gsub(ply:GetModel(), ".mdl", ".png" ) )
        PlayerModelMat.AutoSize = false

        local NameTitle = vgui.Create( "DLabel", PassportPanel )
        NameTitle:SetPos( 206, 64 )
        NameTitle:SetTextColor( Color( 0, 0, 0 ) )
        NameTitle:SetFont( "PassPopup2" )
        NameTitle:SetText( "Name:" )
        NameTitle:SizeToContents()

        local NameLabel = vgui.Create( "DLabel", PassportPanel )
        NameLabel:SetPos( 206, 84 )
        NameLabel:SetTextColor( Color( 0, 0, 0 ) )
        NameLabel:SetFont( "PassPopup1" )
        NameLabel:SetText( ply:Name() or "Unknown" )
        NameLabel:SizeToContents()

        local LicenseTitle = vgui.Create( "DLabel", PassportPanel )
        LicenseTitle:SetPos( 426, 129 )
        LicenseTitle:SetTextColor( Color( 0, 0, 0 ) )
        LicenseTitle:SetFont( "PassPopup2" )
        LicenseTitle:SetText( "Waffenlizenz:" )
        LicenseTitle:SizeToContents()

        local LicenseLabel = vgui.Create( "DLabel", PassportPanel )
        surface.SetFont( "PassPopup3" )
        LicenseLabel:SetPos( 560 - surface.GetTextSize( ply:getDarkRPVar( "HasGunlicense" ) and "Ja" or "Nein" ), 149 )
        LicenseLabel:SetTextColor( Color( 0, 0, 0 ) )
        LicenseLabel:SetFont( "PassPopup3" )
        LicenseLabel:SetText( ply:getDarkRPVar( "HasGunlicense" ) and "Ja" or "Nein" )
        LicenseLabel:SizeToContents()
        --============
        if xtra then
            local JobTitle = vgui.Create( "DLabel", PassportPanel )
            JobTitle:SetPos( 206, 129 )
            JobTitle:SetTextColor( Color( 0, 0, 0 ) )
            JobTitle:SetFont( "PassPopup2" )
            JobTitle:SetText( "Job:" )
            JobTitle:SizeToContents()

            local JobLabel = vgui.Create( "DLabel", PassportPanel )
            JobLabel:SetPos( 206, 149 )
            JobLabel:SetTextColor( Color( 0, 0, 0 ) )
            JobLabel:SetFont( "PassPopup3" )
            JobLabel:SetText( ply:getDarkRPVar("job") or "Unknown" )
            JobLabel:SizeToContents()
        --===========
            local CityTitle = vgui.Create( "DLabel", PassportPanel )
            CityTitle:SetPos( 206, 189 )
            CityTitle:SetTextColor( Color( 0, 0, 0 ) )
            CityTitle:SetFont( "PassPopup2" )
            CityTitle:SetText( "Stadt:" )
            CityTitle:SizeToContents()

            local CityLabel = vgui.Create( "DLabel", PassportPanel )
            CityLabel:SetPos( 206, 209 )
            CityLabel:SetTextColor( Color( 0, 0, 0 ) )
            CityLabel:SetFont( "PassPopup3" )
            CityLabel:SetText( "Homestate" )
            CityLabel:SizeToContents()
        else
            local CityTitle = vgui.Create( "DLabel", PassportPanel )
            CityTitle:SetPos( 206, 189 )
            CityTitle:SetTextColor( Color( 0, 0, 0 ) )
            CityTitle:SetFont( "PassPopup2" )
            CityTitle:SetText( "Info:" )
            CityTitle:SizeToContents()

            local CityLabel = vgui.Create( "DLabel", PassportPanel )
            CityLabel:SetPos( 206, 209 )
            CityLabel:SetTextColor( Color( 0, 0, 0 ) )
            CityLabel:SetFont( "PassPopup3" )
            CityLabel:SetText( "Staatsbeamter" )
            CityLabel:SizeToContents()
        end
        --============
        --"<G<<<<<<<<<<<"..self.Owner:SteamID().."<<<<"
        --"<G<<<2281337<<<<777<<<<06<<<<<<<<<<"
        local GarbleLabelOne = vgui.Create( "DLabel", PassportPanel )
        GarbleLabelOne:SetPos( 5, 288 )
        GarbleLabelOne:SetTextColor( Color( 0, 0, 0, 200 ) )
        GarbleLabelOne:SetFont( "PassPopup3" )
        GarbleLabelOne:SetText( "<G<<<<<<<<<<<"..ply:SteamID().."<<<<" )
        GarbleLabelOne:SizeToContents()

        local GarbleLabelTwo = vgui.Create( "DLabel", PassportPanel )
        GarbleLabelTwo:SetPos( 5, 318 )
        GarbleLabelTwo:SetTextColor( Color( 0, 0, 0, 200 ) )
        GarbleLabelTwo:SetFont( "PassPopup3" )
        GarbleLabelTwo:SetText( "<G<<<2281337<<<<777<<<<06<<<<<<<<<<" )
        GarbleLabelTwo:SizeToContents()

    end )
end